#pragma once;

#include "BushouData.h"
#include "KahouData.h"
#include "CastleData.h"

// RetsudenEditor.cpp : C vWFNg t@CłB
#include <windows.h>
#include <string>

#include "DotNetTestToMultiByte.h"

ref class RetsudenEditorForm : public Form {

//-----------------------------------------------tH[EBhEn

	TabControl^ tcRE;	// ŜłPɂȂĂ^uRg[BTabPage^ǉĂ

    static cli::array<String^>^ aryStrFontCandidate = {"V ", "lr ", "lr SVbN" }; // tHgXg

public:
	RetsudenEditorForm() {
		this->AutoScaleMode = ::AutoScaleMode::Dpi;

		// tH[ɂ̂̏
		this->Text = "HD `GfB^";
		this->Width = 800;
		this->Height = 500;

		SetFormIcon();

		SetTabControl();
	}

	void SetFormIcon() {
		// ̃vWFNg̃AZũ^Cv擾B
		System::Reflection::Assembly^ prj_assebmly = GetType()->Assembly;
		System::Resources::ResourceManager^ r = gcnew System::Resources::ResourceManager(String::Format("{0}.RetsudenEditorRes", prj_assebmly->GetName()->Name), prj_assebmly);

		System::Drawing::Icon^ iconform = (System::Drawing::Icon^)(r->GetObject("icon"));
		this->Icon = iconform;
	}

	// ^uRg[̏BԂɁAef[^Obhr[ւ̃f[^ݏ荞
	void SetTabControl() {
		tcRE = gcnew TabControl();
		tcRE->Size = this->ClientSize;
		
		// `̃^uy[Wǉ
		tpBushou_Init();
		Bushou_SetEventHander();

		// ƕ`̃^uy[Wǉ
		tpKahou_Init();
		Kahou_SetEventHander();

		// `̃^uy[Wǉ
		tpCastle_Init();
		Castle_SetEventHander();

		tcRE->SelectedIndexChanged += gcnew EventHandler(this, &RetsudenEditorForm::tcRE_SelectedIndexChanged);
		this->Controls->Add(tcRE);
	}

	// ^u؂ւ
	void tcRE_SelectedIndexChanged(Object^ sender, EventArgs^ e) {
	}


	int GetStringMeasure(String^ str) {
		char szBufMeasure[128];
		wsprintf( szBufMeasure, "%s", str );
		int iByteNum = strlen( szBufMeasure );
		return iByteNum * 8 + 8;
	}

//-----------------------------------------------`n
private:
	TabPage^ tpBushou;
	BushouData^ bdBushouData;

	TextBox^ tbBushouSearch; // 
	Button^ btnBushouSearch; // {^
	Button^ btnBushouImport; // 捞{^
	OpenFileDialog^ ofdBushouImport;
	Button^ btnBushouExport; // o̓{^
	Button^ btnBushouAllSave; // Sĕۑ

	ListBox^ lbBushouList; // Xg̃R{{bNX
	int iLastBushouListSelected;

	Panel^ plBushouRetsuden;	 // `p̃pl
	TextBox^ tbBushouFullName; // ̃eLXg{bNX
	TextBox^ tbBushouRubyYomi; // ӂ肪Ȃ̂
	TextBox^ tbBushouBornEtc;  // NȂǂ̏
	TextBox^ tbBushouRetsuden; // `


	// tHg
	System::Drawing::Font^ fontBushou;
	ComboBox^ cbFontBushou;	// tHgXg

	Button^ btnBushouAdds; // 50gǉ
	Button^ btnBushouDels; // 50gǉ


private:

	void tpBushou_Init() {

		tpBushou = gcnew TabPage();

		tpBushou->Text = "`";
		tpBushou->Size = tcRE->ClientSize;

		// 
		tbBushouSearch = gcnew TextBox();
		tbBushouSearch->Width = 210;
		tbBushouSearch->Height = 24;
		tbBushouSearch->Left = 10;
		tbBushouSearch->Top = 10;

		// {^
		btnBushouSearch = gcnew Button();
		btnBushouSearch->Text = "";
		btnBushouSearch->Width = 90;
		btnBushouSearch->Height = tbBushouSearch->Height;
		btnBushouSearch->Left = tbBushouSearch->Right + 1;
		btnBushouSearch->Top = tbBushouSearch->Top;

		// 捞{^
		btnBushouImport = gcnew Button();
		btnBushouImport->Text = "PƎ捞";
		btnBushouImport->Width = 105;
		btnBushouImport->Height = tbBushouSearch->Height;
		btnBushouImport->Left = btnBushouSearch->Right + 45;
		btnBushouImport->Top = tbBushouSearch->Top;

		// o̓{^
		btnBushouExport = gcnew Button();
		btnBushouExport->Text = "PƏo";
		btnBushouExport->Width = 105;
		btnBushouExport->Height = tbBushouSearch->Height;
		btnBushouExport->Left = btnBushouImport->Right;
		btnBushouExport->Top = tbBushouSearch->Top;

		// Sĕۑ
		btnBushouAllSave = gcnew Button();
		btnBushouAllSave->Text = "Sĕۑ";
		btnBushouAllSave->Width = 105;
		btnBushouAllSave->Height = tbBushouSearch->Height;
		btnBushouAllSave->Left = tpBushou->Right - (btnBushouAllSave->Width+30);
		btnBushouAllSave->Top = tbBushouSearch->Top;

		// m
		lbBushouList = gcnew ListBox();
		lbBushouList->Width = tbBushouSearch->Width;
		lbBushouList->Left = tbBushouSearch->Left;
		lbBushouList->Top = tbBushouSearch->Bottom + 15;
		lbBushouList->Height = 300;

		// `p̃pl
		plBushouRetsuden = gcnew Panel();
		plBushouRetsuden->Top = lbBushouList->Top;
		Bushou_SetPanelBackImg();
		plBushouRetsuden->Left = lbBushouList->Right+10;
		plBushouRetsuden->Width = 600;
		plBushouRetsuden->Height = 350;

		tbBushouFullName = gcnew TextBox();
		tbBushouFullName->Top = 15;
		tbBushouFullName->Left = 15;
		tbBushouFullName->Width = 160;
		tbBushouFullName->MaxLength = 37;
		tbBushouFullName->BackColor = Color::FromArgb(0xC0, 0xD0, 0xF0);

		tbBushouRubyYomi = gcnew TextBox();
		tbBushouRubyYomi->Top = tbBushouFullName->Top;
		tbBushouRubyYomi->Left = tbBushouFullName->Right+10;
		tbBushouRubyYomi->MaxLength = 37;
		tbBushouRubyYomi->Width = 160;
		tbBushouRubyYomi->BackColor = Color::FromArgb(0xC0, 0xD0, 0xF0);

		tbBushouBornEtc  = gcnew TextBox();
		tbBushouBornEtc->Top = tbBushouFullName->Top;
		tbBushouBornEtc->Left = tbBushouRubyYomi->Right+10;
		tbBushouBornEtc->Width = 160;
		tbBushouBornEtc->MaxLength = 37;
		tbBushouBornEtc->BackColor = Color::FromArgb(0xC0, 0xD0, 0xF0);

		tbBushouRetsuden = gcnew TextBox();
		tbBushouRetsuden->Top = tbBushouFullName->Bottom + 12;
		tbBushouRetsuden->Left = tbBushouFullName->Left;
		tbBushouRetsuden->Height = 135;
		tbBushouRetsuden->Width = (int)(312 * 1.5 + 32);
		tbBushouRetsuden->MaxLength = 2 * 27 * 4;
		tbBushouRetsuden->Multiline = true;
		tbBushouRetsuden->WordWrap = false;
		tbBushouRetsuden->BackColor = Color::FromArgb(0xC0, 0xD0, 0xF0);
		

		plBushouRetsuden->Controls->Add(tbBushouFullName);
		plBushouRetsuden->Controls->Add(tbBushouRubyYomi);
		plBushouRetsuden->Controls->Add(tbBushouBornEtc);
		plBushouRetsuden->Controls->Add(tbBushouRetsuden);

		// tHgXg
		cbFontBushou = gcnew ComboBox();
		cbFontBushou->Width = 150;
		cbFontBushou->Left = lbBushouList->Right + 10;
		cbFontBushou->Top = plBushouRetsuden->Bottom + 15;
		cbFontBushou->Height = tbBushouSearch->Height;
		Bushou_GetValidTenshoukiFontList();

		Bushou_cbFont_SelectedIndexChanged(nullptr, nullptr);

		// g50lǉ
		btnBushouAdds = gcnew Button();
		btnBushouAdds->Text = "50gǉ";
		btnBushouAdds->Width = 70;
		btnBushouAdds->Height = tbBushouSearch->Height;
		btnBushouAdds->Left = tbBushouSearch->Left;
		btnBushouAdds->Top = lbBushouList->Bottom + 10;

		// g50l폜
		btnBushouDels = gcnew Button();
		btnBushouDels->Text = "50g폜";
		btnBushouDels->Width = 70;
		btnBushouDels->Height = tbBushouSearch->Height;
		btnBushouDels->Left = btnBushouAdds->Right;
		btnBushouDels->Top = lbBushouList->Bottom + 10;
		btnBushouAdds->Enabled = false;


		// `̃^uɃR|[lgǉ
		tpBushou->Controls->Add(tbBushouSearch);
		tpBushou->Controls->Add(btnBushouSearch);
//		tpBushou->Controls->Add(btnBushouImport);
//		tpBushou->Controls->Add(btnBushouExport);
		tpBushou->Controls->Add(btnBushouAllSave);
		tpBushou->Controls->Add(lbBushouList);
		tpBushou->Controls->Add(plBushouRetsuden);
//		tpBushou->Controls->Add(cbFontBushou);
//		tpBushou->Controls->Add(btnBushouAdds);
//		tpBushou->Controls->Add(btnBushouDels);
		
		// ^utH[ɒǉ
		tcRE->TabPages->Add(tpBushou);

		// f[^쐬āAXgɗ
		bdBushouData = gcnew BushouData();
		// Xg{bNXɑ
		for ( int i=0; i<bdBushouData->lstStrFullName->Count; i++ ) {
			String^ strLine = String::Format( "{0:0000} - {1}", i, bdBushouData->lstStrFullName[i]);
			lbBushouList->Items->Add( strLine );
		}

		// ŏ̂̂IĂ
		lbBushouList->SelectedIndex = 0;
		iLastBushouListSelected = 0;

		// f[^eLXg{bNX
		Bushou_BDataToTextBox();
		Bushou_TextBoxWidthUpdate();
	}

	// pl̔wi摜ݒ
	void Bushou_SetPanelBackImg() {
		// sv
		return;

		// ̃vWFNg̃AZũ^Cv擾B
		System::Reflection::Assembly^ prj_assebmly = GetType()->Assembly;
		System::Resources::ResourceManager^ r = gcnew System::Resources::ResourceManager(String::Format("{0}.RetsudenEditorRes", prj_assebmly->GetName()->Name), prj_assebmly);

		// pl̔wi
		plBushouRetsuden->BackgroundImage = (System::Drawing::Image^)(r->GetObject("retsuden_back"));
		// wi摜̑傫Ƀpl̑傫킹
		plBushouRetsuden->Size = plBushouRetsuden->BackgroundImage->Size;

	}

	// efth̃Cxgnhݒ
	void Bushou_SetEventHander() {
		btnBushouSearch->Click += gcnew EventHandler(this, &RetsudenEditorForm::Bushou_btnSearch_Click);
		btnBushouImport->Click += gcnew EventHandler(this, &RetsudenEditorForm::Bushou_btnImport_Click);
		btnBushouExport->Click += gcnew EventHandler(this, &RetsudenEditorForm::Bushou_btnExport_Click);
		btnBushouAllSave->Click += gcnew EventHandler(this, &RetsudenEditorForm::Bushou_btnAllSave_Click);
		tbBushouSearch->KeyDown += gcnew KeyEventHandler(this, &RetsudenEditorForm::Bushou_tbSearch_KeyDown);
		lbBushouList->SelectedIndexChanged += gcnew EventHandler(this, &RetsudenEditorForm::Bushou_lbBushouList_SelectedIndexChanged);
		tbBushouFullName->TextChanged += gcnew EventHandler( this, &RetsudenEditorForm::Bushou_tbFullName_TextChanged);
		tbBushouRubyYomi->TextChanged += gcnew EventHandler( this, &RetsudenEditorForm::Bushou_tbRubyYomi_TextChanged);
		tbBushouBornEtc->TextChanged += gcnew EventHandler( this, &RetsudenEditorForm::Bushou_tbBornEtc_TextChanged);
		tbBushouRetsuden->TextChanged += gcnew EventHandler( this, &RetsudenEditorForm::Bushou_tbRetsuden_TextChanged);
		tbBushouFullName->Leave += gcnew EventHandler( this, &RetsudenEditorForm::Bushou_textBox_Leave);
		tbBushouRubyYomi->Leave += gcnew EventHandler( this, &RetsudenEditorForm::Bushou_textBox_Leave);
		tbBushouBornEtc->Leave += gcnew EventHandler( this, &RetsudenEditorForm::Bushou_textBox_Leave);
		tbBushouRetsuden->Leave += gcnew EventHandler( this, &RetsudenEditorForm::Bushou_textBox_Leave);
		cbFontBushou->SelectedIndexChanged += gcnew EventHandler(this, &RetsudenEditorForm::Bushou_cbFont_SelectedIndexChanged);
		btnBushouAdds->Click += gcnew EventHandler(this, &RetsudenEditorForm::Bushou_btnAddBushous_Click);
		btnBushouDels->Click += gcnew EventHandler(this, &RetsudenEditorForm::Bushou_btnDelBushous_Click);
	}

	// {^
	void Bushou_btnSearch_Click(Object^ sender, EventArgs^ e) {
		if ( tbBushouSearch->Text == "" ) { return; } // eLXgGAۂȂ牽ȂB

		int iStart = GetBushouCBSelectedIndex() + 1; // ݑIĂ̂̂玟̌

		Regex^ regex = gcnew Regex(tbBushouSearch->Text);

		bool isExist = false;
		// iStartȍ~ST[`āA
		for ( int i=iStart; i<lbBushouList->Items->Count; i++) {
			Match^ match = regex->Match( (String^)lbBushouList->Items[i] );

			if ( match->Success ) {
				lbBushouList->SelectedIndex = i;
				isExist = true;
				break;
			}
		}

		if ( !isExist ) {
			for ( int i=0; i<iStart; i++) {
				Match^ match = regex->Match( (String^)lbBushouList->Items[i] );

				if ( match->Success ) {
					lbBushouList->SelectedIndex = i;
					break;
				}
			}
		}
	}

	// eLXg{bNXŃL[
	void Bushou_tbSearch_KeyDown(Object^ sender, KeyEventArgs^ e) {
		if (e->KeyCode == Keys::Return ) {
			Bushou_btnSearch_Click(sender, e);
		}
		if (e->KeyCode == Keys::F3 ) {
			Bushou_btnSearch_Click(sender, e);
		}
	}

	// o̓{^
	void Bushou_btnExport_Click(Object^ sender, EventArgs^ e) {
		int iSelectedIndex = GetBushouCBSelectedIndex();
		std::string unmanagedData = bdBushouData->GetOneBushouExportData(iSelectedIndex);

		std::string filepath = DotNetStringToMultiByte(bdBushouData->lstStrFullName[iSelectedIndex]);
		if ( filepath == "" ) { filepath = "ȂȂ"; }
		filepath += ".n6b";

		FILE *fp = fopen(filepath.c_str(), "wb");
		if ( fp ) {
			fwrite( unmanagedData.c_str(), unmanagedData.size(), 1, fp);
			fclose(fp);
			System::Windows::Forms::MessageBox::Show("f[^o͂܂B", "", ::MessageBoxButtons::OK, ::MessageBoxIcon::Information);
		} else {
			System::Windows::Forms::MessageBox::Show("f[^̏o͂Ɏs܂B", "G[", MessageBoxButtons::OK, ::MessageBoxIcon::Error);

		}
	}


	// ̓{^
	void Bushou_btnImport_Click(Object^ sender, EventArgs^ e) {

		ofdBushouImport = gcnew OpenFileDialog();

		ofdBushouImport->InitialDirectory = "."; // c[ƓfBNgftHg

		ofdBushouImport->Filter = "VċL`t@C(*.n6b)|*.n6b";

		ofdBushouImport->FilterIndex = 1;

		ofdBushouImport->Title = "Ƃ镐̗`t@CIĂ";

		//_CAO{bNXOɌ݂̃fBNg𕜌悤ɂ
		ofdBushouImport->RestoreDirectory = true;

		//_CAO\
		if (ofdBushouImport->ShowDialog() == ::DialogResult::OK) {
			//OK{^NbNꂽƂ
			if ( ofdBushouImport->FileName ) {
				BOOL success = bdBushouData->GetOneBushouImportData(ofdBushouImport->FileName, GetBushouCBSelectedIndex());

				//@ۂɂ炸XV
				Bushou_BDataToTextBox();
			}
		}
	}

	// Sĕۑ{^
	void Bushou_btnAllSave_Click(Object^ sender, EventArgs^ e) {
		bdBushouData->AllSaveToBFileN6P();
	}

	// tHgXg̑IڂύXꂽ
	void Bushou_cbFont_SelectedIndexChanged(Object^ sender, EventArgs^ e) {
		// tHg̐ݒ
		fontBushou = gcnew System::Drawing::Font((String^)cbFontBushou->Items[cbFontBushou->SelectedIndex], 12, FontStyle::Regular);
		tbBushouFullName->Font = fontBushou;
		tbBushouRubyYomi->Font = fontBushou;
		tbBushouBornEtc->Font  = fontBushou;
		tbBushouRetsuden->Font = fontBushou;
	}

	// CXg[ĂtHgɂāAtHgXg{bNXɒǉ
	void Bushou_GetValidTenshoukiFontList() {

		//InstalledFontCollectionIuWFNg̎擾
		System::Drawing::Text::InstalledFontCollection^ ifc = gcnew System::Drawing::Text::InstalledFontCollection();

		//CXg[Ă邷ׂẴtHgt@~A擾
		cli::array<FontFamily^>^ ffs = ifc->Families;

		//ł͌ƂȂ肦tHĝ
		for ( int i=0; i<aryStrFontCandidate->Length; i++) {

			// tHgXg
			for each (FontFamily^ ff in ffs) {

				// tHgB
				if (ff->Name == aryStrFontCandidate[i]) {
					// R{{bNXɒǉ
					cbFontBushou->Items->Add( ff->Name );
				}
			}
		}

		// PȏtHgAŏ̂̂IĂB
		if ( cbFontBushou->Items->Count > 0 ) {
			cbFontBushou->SelectedIndex = 0;
		}
	}

	int GetBushouCBSelectedIndex() {
		int iSelectedIndex = lbBushouList->SelectedIndex;
		if ( 0 <= iSelectedIndex && iSelectedIndex < lbBushouList->Items->Count) {
			return iSelectedIndex;
		} else {
			return 0;
		}
	}
	void ModifyCBBushouSelectedIndex() {
		// œ_Ă悤ȂAŌɑIĂ̂B
		int iSelectIndex = GetBushouCBSelectedIndex();
		if ( iSelectIndex == 0xFFFFFFFF ) {
			lbBushouList->SelectedIndex = iLastBushouListSelected;
		} else {
			iLastBushouListSelected = iSelectIndex;
		}
	}


	// XgIύXƁA摜̗̏`e̒lւ
	void Bushou_lbBushouList_SelectedIndexChanged(Object^ sender, EventArgs^ e ) {
		ModifyCBBushouSelectedIndex();
		// Vindex̃f[^擾B
		Bushou_BDataToTextBox();

		ModifyCBBushouSelectedIndex();
	}


	// f[^eLXg{bNX֓]
	void Bushou_BDataToTextBox() {
		int iSelectedIndex = GetBushouCBSelectedIndex();
		tbBushouFullName->Text = bdBushouData->lstStrFullName[iSelectedIndex];
		tbBushouRubyYomi->Text = bdBushouData->lstStrRubyYomi[iSelectedIndex];
		tbBushouBornEtc->Text  = bdBushouData->lstStrBornEtc[iSelectedIndex];
		tbBushouRetsuden->Text = bdBushouData->lstStrRetsuden[iSelectedIndex];
	}

	// eLXg{bNẌʒu╝𒆐g̃eLXgʂɏ]ĕύX
	void Bushou_TextBoxWidthUpdate() {
		// tbBushouFullName->Width = GetStringMeasure(tbBushouFullName->Text);

		// tbBushouRubyYomi->Left = tbBushouFullName->Right + 8;
		// tbBushouRubyYomi->Width = GetStringMeasure(tbBushouRubyYomi->Text);
		
		// tbBushouBornEtc->Left = tbBushouRubyYomi->Right + 8;
		// tbBushouBornEtc->Width = GetStringMeasure(tbBushouBornEtc->Text);
	}

	// eLXg{bNX́AuvύXꂽB
	void Bushou_tbFullName_TextChanged(Object^ sender, EventArgs^ e ) {
		int iSelectedIndex = GetBushouCBSelectedIndex();
		bdBushouData->lstStrFullName[iSelectedIndex] = tbBushouFullName->Text;
		String^ strLine = String::Format( "{0:0000} - {1}", iSelectedIndex, tbBushouFullName->Text);
		// SelectIndexChangeȂ悤ɂB
		lbBushouList->SelectedIndexChanged -= gcnew EventHandler(this, &RetsudenEditorForm::Bushou_lbBushouList_SelectedIndexChanged);

		// Ȃ悤ɂ̂ŁAlBSelectedIndexChange\bhȂ̂ŃG[NȂB

		lbBushouList->Items[iSelectedIndex] = gcnew String(strLine); // Xg̖O̕XV

		Bushou_TextBoxWidthUpdate();

		// XV̂ŁA߂B
		// SelectIndexChange悤ɂB
		lbBushouList->SelectedIndexChanged += gcnew EventHandler(this, &RetsudenEditorForm::Bushou_lbBushouList_SelectedIndexChanged);
	}

	// eLXg{bNX́Auӂ肪ȁvύXꂽB
	void Bushou_tbRubyYomi_TextChanged(Object^ sender, EventArgs^ e ) {
		int iSelectedIndex = GetBushouCBSelectedIndex();
		bdBushouData->lstStrRubyYomi[iSelectedIndex] = tbBushouRubyYomi->Text;
		Bushou_TextBoxWidthUpdate();
	}

	// eLXg{bNX́AuNvύXꂽB
	void Bushou_tbBornEtc_TextChanged(Object^ sender, EventArgs^ e ) {
		int iSelectedIndex = GetBushouCBSelectedIndex();
		bdBushouData->lstStrBornEtc[iSelectedIndex]  = tbBushouBornEtc->Text;
		Bushou_TextBoxWidthUpdate();
	}

	// eLXg{bNX́Au`vύXꂽB
	void Bushou_tbRetsuden_TextChanged(Object^ sender, EventArgs^ e ) {
		int iSelectedIndex = GetBushouCBSelectedIndex();

		bdBushouData->lstStrRetsuden[iSelectedIndex] = tbBushouRetsuden->Text;
	}

	// eLXg{bNX狎
	void Bushou_textBox_Leave(Object^ sender, EventArgs^ e ) {
	}


	// 50gǉ{^
	void Bushou_btnAddBushous_Click(Object^ sender, EventArgs^ e) {
		int iStart = lbBushouList->Items->Count;
		for ( int i = iStart; i < iStart+50; i++ ) {
			String^ bname = String::Format("o^{0:0000}", i);
			// Ɍf[^瑝₷
			bdBushouData->lstStrFullName->Add( bname );
			bdBushouData->lstStrRubyYomi->Add( "ĳ۸"+i );
			bdBushouData->lstStrBornEtc->Add( "????`????" );
			bdBushouData->lstStrRetsuden->Add( "" );
			String^ strLine = String::Format( "{0:0000} - {1}", i, bname);
			lbBushouList->Items->Add( strLine );
		}

	}

	// 50g폜{^
	void Bushou_btnDelBushous_Click(Object^ sender, EventArgs^ e) {
		
		int iStart = lbBushouList->Items->Count-1;

		// ICfbNX폜\̏ɂAMM̂Ƃ܂őޔ
		if ( GetBushouCBSelectedIndex() > iStart - 50 ) {
			lbBushouList->SelectedIndex = iStart - 50;
		}

		for ( int i = iStart; i > iStart-50; i-- ) {
			// ɕXgJbg
			lbBushouList->Items->RemoveAt(i);

			// Ōf[^炷
			bdBushouData->lstStrFullName->RemoveAt( i );
			bdBushouData->lstStrRubyYomi->RemoveAt( i );
			bdBushouData->lstStrBornEtc->RemoveAt( i );
			bdBushouData->lstStrRetsuden->RemoveAt( i );
		}
	}


//-----------------------------------------------ƕ`n
private:
	TabPage^ tpKahou;
	KahouData^ bdKahouData;

	TextBox^ tbKahouSearch; // ƕ󌟍
	Button^ btnKahouSearch; // {^
	Button^ btnKahouImport; // 捞{^
	Button^ btnKahouExport; // o̓{^
	Button^ btnKahouAllSave; // Sĕۑ

	ListBox^ lbKahouList; // ƕ󃊃Xg̃R{{bNX
	int iLastKahouListSelected;

	Panel^ plKahouRetsuden;	 // `p̃pl
	TextBox^ tbKahouFullName; // ƕ󐩖̃eLXg{bNX
	TextBox^ tbKahouRubyYomi; // ӂ肪Ȃ̂
	TextBox^ tbKahouBornEtc;  // NȂǂ̏
	TextBox^ tbKahouRetsuden; // `


	// tHg
	System::Drawing::Font^ fontKahou;
	ComboBox^ cbFontKahou;	// tHgXg

	Button^ btnKahouAdds; // 50gǉ
	Button^ btnKahouDels; // 50gǉ


private:

	void tpKahou_Init() {

		tpKahou = gcnew TabPage();
		tpKahou->BackColor = Color::Transparent;


		tpKahou->Text = "ƕ`";
		tpKahou->Size = tcRE->ClientSize;

		// ƕ󌟍
		tbKahouSearch = gcnew TextBox();
		tbKahouSearch->Width = 210;
		tbKahouSearch->Height = 24;
		tbKahouSearch->Left = 10;
		tbKahouSearch->Top = 10;

		// {^
		btnKahouSearch = gcnew Button();
		btnKahouSearch->Text = "";
		btnKahouSearch->Width = 90;
		btnKahouSearch->Height = tbKahouSearch->Height;
		btnKahouSearch->Left = tbKahouSearch->Right + 1;
		btnKahouSearch->Top = tbKahouSearch->Top;

		// 捞{^
		btnKahouImport = gcnew Button();
		btnKahouImport->Text = "PƎ捞";
		btnKahouImport->Width = 105;
		btnKahouImport->Height = tbKahouSearch->Height;
		btnKahouImport->Left = btnKahouSearch->Right + 45;
		btnKahouImport->Top = tbKahouSearch->Top;

		// o̓{^
		btnKahouExport = gcnew Button();
		btnKahouExport->Text = "PƏo";
		btnKahouExport->Width = 105;
		btnKahouExport->Height = tbKahouSearch->Height;
		btnKahouExport->Left = btnKahouImport->Right;
		btnKahouExport->Top = tbKahouSearch->Top;

		// Sĕۑ
		btnKahouAllSave = gcnew Button();
		btnKahouAllSave->Text = "Sĕۑ";
		btnKahouAllSave->Width = 105;
		btnKahouAllSave->Height = tbKahouSearch->Height;
		btnKahouAllSave->Left = tpKahou->Right - (btnKahouAllSave->Width+30);
		btnKahouAllSave->Top = tbKahouSearch->Top;

		// ƕm
		lbKahouList = gcnew ListBox();
		lbKahouList->Width = tbKahouSearch->Width;
		lbKahouList->Left = tbKahouSearch->Left;
		lbKahouList->Top = tbKahouSearch->Bottom + 15;
		lbKahouList->Height = 300;

		// `p̃pl
		plKahouRetsuden = gcnew Panel();
		plKahouRetsuden->Top = lbKahouList->Top;
		Kahou_SetPanelBackImg();
		plKahouRetsuden->Left = lbKahouList->Right + 10;
		plKahouRetsuden->Width = 600;
		plKahouRetsuden->Height = 350;

		tbKahouFullName = gcnew TextBox();
		tbKahouFullName->Top = 15;
		tbKahouFullName->Left = 15;
		tbKahouFullName->Width = 160;
		tbKahouFullName->MaxLength = 37;
		tbKahouFullName->BackColor = Color::FromArgb(0xC0, 0xD0, 0xF0);

		tbKahouRubyYomi = gcnew TextBox();
		tbKahouRubyYomi->Top = tbKahouFullName->Top;
		tbKahouRubyYomi->Left = tbKahouFullName->Right + 10;
		tbKahouRubyYomi->MaxLength = 37;
		tbKahouRubyYomi->Width = 160;
		tbKahouRubyYomi->BackColor = Color::FromArgb(0xC0, 0xD0, 0xF0);

		tbKahouBornEtc  = gcnew TextBox();
		tbKahouBornEtc->Top = tbKahouFullName->Top;
		tbKahouBornEtc->Left = tbKahouRubyYomi->Right + 10;
		tbKahouBornEtc->Width = 160;
		tbKahouBornEtc->MaxLength = 37;
		tbKahouBornEtc->BackColor = Color::FromArgb(0xC0, 0xD0, 0xF0);

		tbKahouRetsuden = gcnew TextBox();
		tbKahouRetsuden->Top = tbKahouFullName->Bottom + 12;
		tbKahouRetsuden->Left = tbKahouFullName->Left;
		tbKahouRetsuden->Height = 135;
		tbKahouRetsuden->Width = (int)(312 * 1.5 + 32);
		tbKahouRetsuden->MaxLength = 2 * 27 * 4;
		tbKahouRetsuden->Multiline = true;
		tbKahouRetsuden->WordWrap = false;
		tbKahouRetsuden->BackColor = Color::FromArgb(0xC0, 0xD0, 0xF0);
		

		plKahouRetsuden->Controls->Add(tbKahouFullName);
		plKahouRetsuden->Controls->Add(tbKahouRubyYomi);
		// plKahouRetsuden->Controls->Add(tbKahouBornEtc);
		plKahouRetsuden->Controls->Add(tbKahouRetsuden);

		// tHgXg
		cbFontKahou = gcnew ComboBox();
		cbFontKahou->Width = 150;
		cbFontKahou->Left = lbKahouList->Right + 10;
		cbFontKahou->Top = plKahouRetsuden->Bottom + 15;
		cbFontKahou->Height = tbKahouSearch->Height;
		Kahou_GetValidTenshoukiFontList();

		Kahou_cbFont_SelectedIndexChanged(nullptr, nullptr);

		// ƕg50lǉ
		btnKahouAdds = gcnew Button();
		btnKahouAdds->Text = "50gǉ";
		btnKahouAdds->Width = 70;
		btnKahouAdds->Height = tbKahouSearch->Height;
		btnKahouAdds->Left = tbKahouSearch->Left;
		btnKahouAdds->Top = lbKahouList->Bottom + 10;

		// ƕg50l폜
		btnKahouDels = gcnew Button();
		btnKahouDels->Text = "50g폜";
		btnKahouDels->Width = 70;
		btnKahouDels->Height = tbKahouSearch->Height;
		btnKahouDels->Left = btnKahouAdds->Right;
		btnKahouDels->Top = lbKahouList->Bottom + 10;


		// ƕ`̃^uɃR|[lgǉ
		tpKahou->Controls->Add(tbKahouSearch);
		tpKahou->Controls->Add(btnKahouSearch);
		// tpKahou->Controls->Add(btnKahouImport);
		// tpKahou->Controls->Add(btnKahouExport);
		tpKahou->Controls->Add(btnKahouAllSave);
		tpKahou->Controls->Add(lbKahouList);
		tpKahou->Controls->Add(plKahouRetsuden);
		// tpKahou->Controls->Add(cbFontKahou);
		// tpKahou->Controls->Add(btnKahouAdds); // ƕpɂ͂̃{^͕sv
		// tpKahou->Controls->Add(btnKahouDels); // ƕpɂ͂̃{^͕sv
		
		// ^utH[ɒǉ
		tcRE->TabPages->Add(tpKahou);

		// ƕf[^쐬āAXgɗ
		bdKahouData = gcnew KahouData();
		// Xg{bNXɑ
		for ( int i=0; i<bdKahouData->lstStrFullName->Count; i++ ) {
			String^ strLine = String::Format( "{0:000} - {1}", i, bdKahouData->lstStrFullName[i]);
			lbKahouList->Items->Add( strLine );
		}

		// ŏ̂̂IĂ
		lbKahouList->SelectedIndex = 0;
		iLastKahouListSelected = 0;

		// ƕf[^eLXg{bNX
		Kahou_BDataToTextBox();
		Kahou_TextBoxWidthUpdate();
	}

	// pl̔wi摜ݒ
	void Kahou_SetPanelBackImg() {
		return; 
		// ̃vWFNg̃AZũ^Cv擾B
		System::Reflection::Assembly^ prj_assebmly = GetType()->Assembly;
		System::Resources::ResourceManager^ r = gcnew System::Resources::ResourceManager(String::Format("{0}.RetsudenEditorRes", prj_assebmly->GetName()->Name), prj_assebmly);

		// pl̔wi
		plKahouRetsuden->BackgroundImage = (System::Drawing::Image^)(r->GetObject("retsuden_back"));
		// wi摜̑傫Ƀpl̑傫킹
		plKahouRetsuden->Size = plKahouRetsuden->BackgroundImage->Size;

	}

	// efth̃Cxgnhݒ
	void Kahou_SetEventHander() {
		btnKahouSearch->Click += gcnew EventHandler(this, &RetsudenEditorForm::Kahou_btnSearch_Click);
		btnKahouImport->Click += gcnew EventHandler(this, &RetsudenEditorForm::Kahou_btnImport_Click);
		btnKahouExport->Click += gcnew EventHandler(this, &RetsudenEditorForm::Kahou_btnExport_Click);
		btnKahouAllSave->Click += gcnew EventHandler(this, &RetsudenEditorForm::Kahou_btnAllSave_Click);
		tbKahouSearch->KeyDown += gcnew KeyEventHandler(this, &RetsudenEditorForm::Kahou_tbSearch_KeyDown);
		lbKahouList->SelectedIndexChanged += gcnew EventHandler(this, &RetsudenEditorForm::Kahou_lbKahouList_SelectedIndexChanged);
		tbKahouFullName->TextChanged += gcnew EventHandler( this, &RetsudenEditorForm::Kahou_tbFullName_TextChanged);
		tbKahouRubyYomi->TextChanged += gcnew EventHandler( this, &RetsudenEditorForm::Kahou_tbRubyYomi_TextChanged);
		tbKahouBornEtc->TextChanged += gcnew EventHandler( this, &RetsudenEditorForm::Kahou_tbBornEtc_TextChanged);
		tbKahouRetsuden->TextChanged += gcnew EventHandler( this, &RetsudenEditorForm::Kahou_tbRetsuden_TextChanged);
		tbKahouFullName->Leave += gcnew EventHandler( this, &RetsudenEditorForm::Kahou_textBox_Leave);
		tbKahouRubyYomi->Leave += gcnew EventHandler( this, &RetsudenEditorForm::Kahou_textBox_Leave);
		tbKahouBornEtc->Leave += gcnew EventHandler( this, &RetsudenEditorForm::Kahou_textBox_Leave);
		tbKahouRetsuden->Leave += gcnew EventHandler( this, &RetsudenEditorForm::Kahou_textBox_Leave);
		cbFontKahou->SelectedIndexChanged += gcnew EventHandler(this, &RetsudenEditorForm::Kahou_cbFont_SelectedIndexChanged);
		btnKahouAdds->Click += gcnew EventHandler(this, &RetsudenEditorForm::Kahou_btnAddKahous_Click);
		btnKahouDels->Click += gcnew EventHandler(this, &RetsudenEditorForm::Kahou_btnDelKahous_Click);
	}

	// ƕ󌟍{^
	void Kahou_btnSearch_Click(Object^ sender, EventArgs^ e) {
		if ( tbKahouSearch->Text == "" ) { return; } // eLXgGAۂȂ牽ȂB

		int iStart = GetKahouCBSelectedIndex() + 1; // ݑIĂ̂̂玟̌

		Regex^ regex = gcnew Regex(tbKahouSearch->Text);

		bool isExist = false;
		// iStartȍ~ST[`āA
		for ( int i=iStart; i<lbKahouList->Items->Count; i++) {
			Match^ match = regex->Match( (String^)lbKahouList->Items[i] );

			if ( match->Success ) {
				lbKahouList->SelectedIndex = i;
				isExist = true;
				break;
			}
		}

		if ( !isExist ) {
			for ( int i=0; i<iStart; i++) {
				Match^ match = regex->Match( (String^)lbKahouList->Items[i] );

				if ( match->Success ) {
					lbKahouList->SelectedIndex = i;
					break;
				}
			}
		}
	}

	// ƕ󌟍eLXg{bNXŃL[
	void Kahou_tbSearch_KeyDown(Object^ sender, KeyEventArgs^ e) {
		if (e->KeyCode == Keys::Return ) {
			Kahou_btnSearch_Click(sender, e);
		}
		if (e->KeyCode == Keys::F3 ) {
			Kahou_btnSearch_Click(sender, e);
		}
	}

	// ƕo̓{^
	void Kahou_btnExport_Click(Object^ sender, EventArgs^ e) {
	}


	// ƕ̓{^
	void Kahou_btnImport_Click(Object^ sender, EventArgs^ e) {
	}

	// Sĕۑ{^
	void Kahou_btnAllSave_Click(Object^ sender, EventArgs^ e) {
		bdKahouData->AllSaveToMessageN6P();
	}

	// tHgXg̑IڂύXꂽ
	void Kahou_cbFont_SelectedIndexChanged(Object^ sender, EventArgs^ e) {
		// tHg̐ݒ
		fontKahou = gcnew System::Drawing::Font((String^)cbFontKahou->Items[cbFontKahou->SelectedIndex], 12, FontStyle::Regular);
		tbKahouFullName->Font = fontKahou;
		tbKahouRubyYomi->Font = fontKahou;
		tbKahouBornEtc->Font  = fontKahou;
		tbKahouRetsuden->Font = fontKahou;
	}

	// CXg[ĂtHgɂāAtHgXg{bNXɒǉ
	void Kahou_GetValidTenshoukiFontList() {

		//InstalledFontCollectionIuWFNg̎擾
		System::Drawing::Text::InstalledFontCollection^ ifc = gcnew System::Drawing::Text::InstalledFontCollection();

		//CXg[Ă邷ׂẴtHgt@~A擾
		cli::array<FontFamily^>^ ffs = ifc->Families;

		//ł͌ƂȂ肦tHĝ
		for ( int i=0; i<aryStrFontCandidate->Length; i++) {

			// tHgXg
			for each (FontFamily^ ff in ffs) {

				// tHgB
				if (ff->Name == aryStrFontCandidate[i]) {
					// R{{bNXɒǉ
					cbFontKahou->Items->Add( ff->Name );
				}
			}
		}

		// PȏtHgAŏ̂̂IĂB
		if ( cbFontKahou->Items->Count > 0 ) {
			cbFontKahou->SelectedIndex = 0;
		}
	}

	int GetKahouCBSelectedIndex() {
		int iSelectedIndex = lbKahouList->SelectedIndex;
		if ( 0 <= iSelectedIndex && iSelectedIndex < lbKahouList->Items->Count) {
			return iSelectedIndex;
		} else {
			return 0;
		}
	}
	void ModifyCBKahouSelectedIndex() {
		// œ_Ă悤ȂAŌɑIĂ̂B
		int iSelectIndex = GetKahouCBSelectedIndex();
		if ( iSelectIndex == 0xFFFFFFFF ) {
			lbKahouList->SelectedIndex = iLastKahouListSelected;
		} else {
			iLastKahouListSelected = iSelectIndex;
		}
	}


	// ƕ󃊃XgIύXƁA摜̗̏`e̒lւ
	void Kahou_lbKahouList_SelectedIndexChanged(Object^ sender, EventArgs^ e ) {
		ModifyCBKahouSelectedIndex();
		// Vindex̃f[^擾B
		Kahou_BDataToTextBox();

		ModifyCBKahouSelectedIndex();
	}


	// ƕf[^eLXg{bNX֓]
	void Kahou_BDataToTextBox() {
		int iSelectedIndex = GetKahouCBSelectedIndex();
		tbKahouFullName->Text = bdKahouData->lstStrFullName[iSelectedIndex];
		tbKahouRubyYomi->Text = bdKahouData->lstStrRubyYomi[iSelectedIndex];
		tbKahouBornEtc->Text  = bdKahouData->lstStrBornEtc[iSelectedIndex];
		tbKahouRetsuden->Text = bdKahouData->lstStrRetsuden[iSelectedIndex];
	}

	// eLXg{bNẌʒu╝𒆐g̃eLXgʂɏ]ĕύX
	void Kahou_TextBoxWidthUpdate() {
		return;

		tbKahouFullName->Width = GetStringMeasure(tbKahouFullName->Text);

		tbKahouRubyYomi->Left = tbKahouFullName->Right + 8;
		tbKahouRubyYomi->Width = GetStringMeasure(tbKahouRubyYomi->Text);
		
		tbKahouBornEtc->Left = tbKahouRubyYomi->Right + 8;
		tbKahouBornEtc->Width = GetStringMeasure(tbKahouBornEtc->Text);
	}

	// eLXg{bNX́Auƕ󐩖vύXꂽB
	void Kahou_tbFullName_TextChanged(Object^ sender, EventArgs^ e ) {
		int iSelectedIndex = GetKahouCBSelectedIndex();
		bdKahouData->lstStrFullName[iSelectedIndex] = tbKahouFullName->Text;
		String^ strLine = String::Format( "{0:000} - {1}", iSelectedIndex, tbKahouFullName->Text);
		// SelectIndexChangeȂ悤ɂB
		lbKahouList->SelectedIndexChanged -= gcnew EventHandler(this, &RetsudenEditorForm::Kahou_lbKahouList_SelectedIndexChanged);

		// Ȃ悤ɂ̂ŁAlBSelectedIndexChange\bhȂ̂ŃG[NȂB

		lbKahouList->Items[iSelectedIndex] = gcnew String(strLine); // ƕ󃊃Xg̖O̕XV

		Kahou_TextBoxWidthUpdate();

		// XV̂ŁA߂B
		// SelectIndexChange悤ɂB
		lbKahouList->SelectedIndexChanged += gcnew EventHandler(this, &RetsudenEditorForm::Kahou_lbKahouList_SelectedIndexChanged);
	}

	// eLXg{bNX́Auӂ肪ȁvύXꂽB
	void Kahou_tbRubyYomi_TextChanged(Object^ sender, EventArgs^ e ) {
		int iSelectedIndex = GetKahouCBSelectedIndex();
		bdKahouData->lstStrRubyYomi[iSelectedIndex] = tbKahouRubyYomi->Text;
		Kahou_TextBoxWidthUpdate();
	}

	// eLXg{bNX́AuNvύXꂽB
	void Kahou_tbBornEtc_TextChanged(Object^ sender, EventArgs^ e ) {
		int iSelectedIndex = GetKahouCBSelectedIndex();
		bdKahouData->lstStrBornEtc[iSelectedIndex]  = tbKahouBornEtc->Text;
		Kahou_TextBoxWidthUpdate();
	}

	// eLXg{bNX́Au`vύXꂽB
	void Kahou_tbRetsuden_TextChanged(Object^ sender, EventArgs^ e ) {
		int iSelectedIndex = GetKahouCBSelectedIndex();

		bdKahouData->lstStrRetsuden[iSelectedIndex] = tbKahouRetsuden->Text;
	}

	// eLXg{bNX狎
	void Kahou_textBox_Leave(Object^ sender, EventArgs^ e ) {
	}


	// 50gǉ{^
	void Kahou_btnAddKahous_Click(Object^ sender, EventArgs^ e) {
	}

	// 50g폜{^
	void Kahou_btnDelKahous_Click(Object^ sender, EventArgs^ e) {
	}

//-----------------------------------------------`n
private:
	TabPage^ tpCastle;
	CastleData^ bdCastleData;

	TextBox^ tbCastleSearch; // 錟
	Button^ btnCastleSearch; // {^
	Button^ btnCastleImport; // 捞{^
	Button^ btnCastleExport; // o̓{^
	Button^ btnCastleAllSave; // Sĕۑ

	TreeView^ tvCastleList; // 郊Xg̃c[r[
	int iLastCastleListSelected;
	List<TreeNode^>^ refTvCastleListNodes; // 郊Xg̃c[r[ɂm[h̃t@X

	Panel^ plCastleRetsuden;	 // `p̃pl
	TextBox^ tbCastleFullName; // 鐩̃eLXg{bNX
	TextBox^ tbCastleRubyYomi; // ӂ肪Ȃ̂
	TextBox^ tbCastleBornEtc;  // NȂǂ̏
	TextBox^ tbCastleRetsuden; // `


	// tHg
	System::Drawing::Font^ fontCastle;
	ComboBox^ cbFontCastle;	// tHgXg

	Button^ btnCastleAdds; // 50gǉ
	Button^ btnCastleDels; // 50gǉ


private:

	void tpCastle_Init() {

		tpCastle = gcnew TabPage();
		tpCastle->BackColor = Color::Transparent;

		tpCastle->Text = "`";
		tpCastle->Size = tcRE->ClientSize;

		// 錟
		tbCastleSearch = gcnew TextBox();
		tbCastleSearch->Width = 210;
		tbCastleSearch->Height = 24;
		tbCastleSearch->Left = 10;
		tbCastleSearch->Top = 10;

		// {^
		btnCastleSearch = gcnew Button();
		btnCastleSearch->Text = "";
		btnCastleSearch->Width = 90;
		btnCastleSearch->Height = tbCastleSearch->Height;
		btnCastleSearch->Left = tbCastleSearch->Right + 1;
		btnCastleSearch->Top = tbCastleSearch->Top;

		// 捞{^
		btnCastleImport = gcnew Button();
		btnCastleImport->Text = "PƎ捞";
		btnCastleImport->Width = 105;
		btnCastleImport->Height = tbCastleSearch->Height;
		btnCastleImport->Left = btnCastleSearch->Right + 45;
		btnCastleImport->Top = tbCastleSearch->Top;

		// o̓{^
		btnCastleExport = gcnew Button();
		btnCastleExport->Text = "PƏo";
		btnCastleExport->Width = 105;
		btnCastleExport->Height = tbCastleSearch->Height;
		btnCastleExport->Left = btnCastleImport->Right;
		btnCastleExport->Top = tbCastleSearch->Top;

		// Sĕۑ
		btnCastleAllSave = gcnew Button();
		btnCastleAllSave->Text = "Sĕۑ";
		btnCastleAllSave->Width = 105;
		btnCastleAllSave->Height = tbCastleSearch->Height;
		btnCastleAllSave->Left = tpCastle->Right - (btnCastleAllSave->Width+30);
		btnCastleAllSave->Top = tbCastleSearch->Top;

		// m
		tvCastleList = gcnew TreeView();
		tvCastleList->HideSelection = false;
		tvCastleList->Width = tbCastleSearch->Width;
		tvCastleList->Left = tbCastleSearch->Left;
		tvCastleList->Top = tbCastleSearch->Bottom + 15;
		tvCastleList->Height = 300;

		// `p̃pl
		plCastleRetsuden = gcnew Panel();
		plCastleRetsuden->Top = tvCastleList->Top;
		Castle_SetPanelBackImg();
		plCastleRetsuden->Left = tvCastleList->Right + 10;
		plCastleRetsuden->Width = 600;
		plCastleRetsuden->Height = 350;

		tbCastleFullName = gcnew TextBox();
		tbCastleFullName->Top = 15;
		tbCastleFullName->Left = 15;
		tbCastleFullName->Width = 160;
		tbCastleFullName->MaxLength = 37;
		tbCastleFullName->BackColor = Color::FromArgb(0xC0, 0xD0, 0xF0);

		tbCastleRubyYomi = gcnew TextBox();
		tbCastleRubyYomi->Top = tbCastleFullName->Top;
		tbCastleRubyYomi->Left = tbCastleFullName->Right + 10;
		tbCastleRubyYomi->MaxLength = 37;
		tbCastleRubyYomi->Width = 160;
		tbCastleRubyYomi->BackColor = Color::FromArgb(0xC0, 0xD0, 0xF0);

		tbCastleBornEtc  = gcnew TextBox();
		tbCastleBornEtc->Top = tbCastleFullName->Top;
		tbCastleBornEtc->Left = tbCastleRubyYomi->Right + 10;
		tbCastleBornEtc->Width = 160;
		tbCastleBornEtc->MaxLength = 37;
		tbCastleBornEtc->BackColor = Color::FromArgb(0xC0, 0xD0, 0xF0);

		tbCastleRetsuden = gcnew TextBox();
		tbCastleRetsuden->Top = tbCastleFullName->Bottom + 12;
		tbCastleRetsuden->Left = tbCastleFullName->Left;
		tbCastleRetsuden->Height = 135;
		tbCastleRetsuden->Width = (int)(312 * 1.5 + 32);
		tbCastleRetsuden->MaxLength = 2 * 27 * 4;
		tbCastleRetsuden->Multiline = true;
		tbCastleRetsuden->WordWrap = false;
		tbCastleRetsuden->BackColor = Color::FromArgb(0xC0, 0xD0, 0xF0);
		

		plCastleRetsuden->Controls->Add(tbCastleFullName);
		plCastleRetsuden->Controls->Add(tbCastleRubyYomi);
		// plCastleRetsuden->Controls->Add(tbCastleBornEtc);
		plCastleRetsuden->Controls->Add(tbCastleRetsuden);

		// tHgXg
		cbFontCastle = gcnew ComboBox();
		cbFontCastle->Width = 100;
		cbFontCastle->Left = tvCastleList->Right + 10;
		cbFontCastle->Top = plCastleRetsuden->Bottom + 15;
		cbFontCastle->Height = tbCastleSearch->Height;
		Castle_GetValidTenshoukiFontList();

		Castle_cbFont_SelectedIndexChanged(nullptr, nullptr);

		// g50lǉ
		btnCastleAdds = gcnew Button();
		btnCastleAdds->Text = "50gǉ";
		btnCastleAdds->Width = 70;
		btnCastleAdds->Height = tbCastleSearch->Height;
		btnCastleAdds->Left = tbCastleSearch->Left;
		btnCastleAdds->Top = tvCastleList->Bottom + 10;

		// g50l폜
		btnCastleDels = gcnew Button();
		btnCastleDels->Text = "50g폜";
		btnCastleDels->Width = 70;
		btnCastleDels->Height = tbCastleSearch->Height;
		btnCastleDels->Left = btnCastleAdds->Right;
		btnCastleDels->Top = tvCastleList->Bottom + 10;


		// `̃^uɃR|[lgǉ
		tpCastle->Controls->Add(tbCastleSearch);
		tpCastle->Controls->Add(btnCastleSearch);
		// tpCastle->Controls->Add(btnCastleImport);
		// tpCastle->Controls->Add(btnCastleExport);
		tpCastle->Controls->Add(btnCastleAllSave);
		tpCastle->Controls->Add(tvCastleList);
		tpCastle->Controls->Add(plCastleRetsuden);
		// tpCastle->Controls->Add(cbFontCastle);
		// tpCastle->Controls->Add(btnCastleAdds); // pɂ͂̃{^͕sv
		// tpCastle->Controls->Add(btnCastleDels); // pɂ͂̃{^͕sv
		
		// ^utH[ɒǉ
		tcRE->TabPages->Add(tpCastle);

		// f[^쐬āAXgɗ
		bdCastleData = gcnew CastleData();

		// t@Xp̂߁B₷邽߁B
		refTvCastleListNodes = gcnew List<TreeNode^>();

		// c[r[ɗvf𑫂
		Castle_AddElementTreeView();

		// ŏ̂̂IĂ
		iLastCastleListSelected = 0;

		// f[^eLXg{bNX
		Castle_BDataToTextBox();
		Castle_TextBoxWidthUpdate();
	}

	// c[r[ɗvf𑫂
	void Castle_AddElementTreeView() {
		// Xg{bNXɑ
		for ( int i=0; i<bdCastleData->lstStrFullName->Count; i++ ) {
			String^ strLine = String::Format( "{0:000} - {1}", i, bdCastleData->lstStrFullName[i]);

			TreeNode^ treeNode;
			List<TreeNode^>^ treeNodeNestList = gcnew List<TreeNode^>();

			// Qȏ̏邪PZbgɂȂĂꍇBTuɃm[h
			if ( vCastleInfoListData[i].size() >= 2) { 
				cli::array<TreeNode^>^ treeSubNodeList = gcnew cli::array<TreeNode^>( vCastleInfoListData[i].size()-1 ); 
				for (int j=1; j<(int)vCastleInfoListData[i].size(); j++) {
					TreeNode^ treeNode = gcnew TreeNode( gcnew String(vCastleInfoListData[i][j].szFullName) );
					treeSubNodeList[j-1] = treeNode;

					// ʂ̂߁A^OĂ
					List<int>^ pair = gcnew List<int>;
					pair->Add(i);
					pair->Add(j);
					treeNode->Tag = pair;

					treeNodeNestList->Add(treeNode);

				}
				treeNode = gcnew TreeNode(strLine, treeSubNodeList); // ̃m[hqƂĂB
				treeNode->ExpandAll();

			} else {
				treeNode = gcnew TreeNode(strLine);
			}

			// ʂ̂߁A^OĂ
			List<int>^ pair = gcnew List<int>;
			pair->Add(i);
			pair->Add(0);
			treeNode->Tag = pair;

			// ׂԂŌ₷悤ɁAt@XpɂĂ
			refTvCastleListNodes->Add(treeNode);
			// lXgőB
			for ( int j=0; j<treeNodeNestList->Count; j++ ) {
				// ׂԂŌ₷悤ɁAt@XpɂĂ
				refTvCastleListNodes->Add(treeNodeNestList[j]);
			}
			// TreeViewerɑĂ
			tvCastleList->Nodes->Add( treeNode );

			// ߂ĂAtH[JX
			if (i==0) {
				tvCastleList->SelectedNode = treeNode;
			}
		}

	}

	// pl̔wi摜ݒ
	void Castle_SetPanelBackImg() {
		return;
		// ̃vWFNg̃AZũ^Cv擾B
		System::Reflection::Assembly^ prj_assebmly = GetType()->Assembly;
		System::Resources::ResourceManager^ r = gcnew System::Resources::ResourceManager(String::Format("{0}.RetsudenEditorRes", prj_assebmly->GetName()->Name), prj_assebmly);

		// pl̔wi
		plCastleRetsuden->BackgroundImage = (System::Drawing::Image^)(r->GetObject("retsuden_back"));
		// wi摜̑傫Ƀpl̑傫킹
		plCastleRetsuden->Size = plCastleRetsuden->BackgroundImage->Size;

	}

	// efth̃Cxgnhݒ
	void Castle_SetEventHander() {
		btnCastleSearch->Click += gcnew EventHandler(this, &RetsudenEditorForm::Castle_btnSearch_Click);
		btnCastleAllSave->Click += gcnew EventHandler(this, &RetsudenEditorForm::Castle_btnAllSave_Click);
		tbCastleSearch->KeyDown += gcnew KeyEventHandler(this, &RetsudenEditorForm::Castle_tbSearch_KeyDown);
		tbCastleFullName->TextChanged += gcnew EventHandler( this, &RetsudenEditorForm::Castle_tbFullName_TextChanged);
		tbCastleRubyYomi->TextChanged += gcnew EventHandler( this, &RetsudenEditorForm::Castle_tbRubyYomi_TextChanged);
		tbCastleRetsuden->TextChanged += gcnew EventHandler( this, &RetsudenEditorForm::Castle_tbRetsuden_TextChanged);
		cbFontCastle->SelectedIndexChanged += gcnew EventHandler(this, &RetsudenEditorForm::Castle_cbFont_SelectedIndexChanged);
		tvCastleList->AfterSelect += gcnew TreeViewEventHandler(this, &RetsudenEditorForm::Castle_tvCastleList_AfterSelect);
	}

	// 錟{^
	void Castle_btnSearch_Click(Object^ sender, EventArgs^ e) {

		if ( tbCastleSearch->Text == "" ) { return; } // eLXgGAۂȂ牽ȂB

		int iStart = GetCastleFlatSelectedIndex() + 1; // ݑIĂ̂̂玟̌

		Regex^ regex = gcnew Regex(tbCastleSearch->Text);

		bool isExist = false;
		// iStartȍ~ST[`āA
		for ( int i=iStart; i<refTvCastleListNodes->Count; i++) {
			Match^ match = regex->Match( refTvCastleListNodes[i]->Text );

			if ( match->Success ) {
				tvCastleList->SelectedNode = refTvCastleListNodes[i];
				isExist = true;
				break;
			}
		}

		if ( !isExist ) {
			for ( int i=0; i<iStart; i++) {
				Match^ match = regex->Match( refTvCastleListNodes[i]->Text );

				if ( match->Success ) {
					tvCastleList->SelectedNode = refTvCastleListNodes[i];
					break;
				}
			}
		}
	}

	// 錟eLXg{bNXŃL[
	void Castle_tbSearch_KeyDown(Object^ sender, KeyEventArgs^ e) {
		if (e->KeyCode == Keys::Return ) {
			Castle_btnSearch_Click(sender, e);
		}
		if (e->KeyCode == Keys::F3 ) {
			Castle_btnSearch_Click(sender, e);
		}
	}

	// Sĕۑ{^
	void Castle_btnAllSave_Click(Object^ sender, EventArgs^ e) {
		bdCastleData->AllSaveToMessageN6P();
	}

	// tHgXg̑IڂύXꂽ
	void Castle_cbFont_SelectedIndexChanged(Object^ sender, EventArgs^ e) {
		// tHg̐ݒ
		fontCastle = gcnew System::Drawing::Font((String^)cbFontCastle->Items[cbFontCastle->SelectedIndex], 12, FontStyle::Regular);
		tbCastleFullName->Font = fontCastle;
		tbCastleRubyYomi->Font = fontCastle;
		tbCastleBornEtc->Font  = fontCastle;
		tbCastleRetsuden->Font = fontCastle;
	}

	// CXg[ĂtHgɂāAtHgXg{bNXɒǉ
	void Castle_GetValidTenshoukiFontList() {

		//InstalledFontCollectionIuWFNg̎擾
		System::Drawing::Text::InstalledFontCollection^ ifc = gcnew System::Drawing::Text::InstalledFontCollection();

		//CXg[Ă邷ׂẴtHgt@~A擾
		cli::array<FontFamily^>^ ffs = ifc->Families;

		//ł͌ƂȂ肦tHĝ
		for ( int i=0; i<aryStrFontCandidate->Length; i++) {

			// tHgXg
			for each (FontFamily^ ff in ffs) {

				// tHgB
				if (ff->Name == aryStrFontCandidate[i]) {
					// R{{bNXɒǉ
					cbFontCastle->Items->Add( ff->Name );
				}
			}
		}

		// PȏtHgAŏ̂̂IĂB
		if ( cbFontCastle->Items->Count > 0 ) {
			cbFontCastle->SelectedIndex = 0;
		}
	}

	// ()AIĂm[hID𓾂BIĂȂ΁A0
	int GetCastleFlatSelectedIndex() {
		
		TreeNode^ iSelectedNode = tvCastleList->SelectedNode;
		for ( int i=0; i < refTvCastleListNodes->Count; i++ ) {
			if ( iSelectedNode == refTvCastleListNodes[i] ) {
				return i;
			}
		}
		return 0;
	}


	// c[̂ǂꂩIꂽ
	void Castle_tvCastleList_AfterSelect(Object^ sender, TreeViewEventArgs^ e) {
		// Vindex̃f[^擾B
		Castle_BDataToTextBox();
	}


	// f[^eLXg{bNX֓]
	void Castle_BDataToTextBox() {
		TreeNode^ tnSelectedNode = tvCastleList->SelectedNode;
		List<int>^ pair = (List<int>^)tnSelectedNode->Tag;
		int iMainIndex = pair[0];
		int iSubIndex = pair[1];
		tbCastleFullName->Text = gcnew String(vCastleInfoListData[iMainIndex][iSubIndex].szFullName);
		tbCastleRubyYomi->Text = gcnew String(vCastleInfoListData[iMainIndex][iSubIndex].szRubyYomi);
		tbCastleRetsuden->Text = gcnew String(vCastleRetsudenInfoListData[iMainIndex][iSubIndex].szRetsuden);
	}

	// eLXg{bNẌʒu╝𒆐g̃eLXgʂɏ]ĕύX
	void Castle_TextBoxWidthUpdate() {
		return;

		tbCastleFullName->Width = GetStringMeasure(tbCastleFullName->Text);

		tbCastleRubyYomi->Left = tbCastleFullName->Right + 8;
		tbCastleRubyYomi->Width = GetStringMeasure(tbCastleRubyYomi->Text);
		
		tbCastleBornEtc->Left = tbCastleRubyYomi->Right + 8;
		tbCastleBornEtc->Width = GetStringMeasure(tbCastleBornEtc->Text);
	}

	// eLXg{bNX́Au鐩vύXꂽB
	void Castle_tbFullName_TextChanged(Object^ sender, EventArgs^ e ) {
		// Im[hID
		TreeNode^ tnSelectedNode = tvCastleList->SelectedNode;
		List<int>^ pair = (List<int>^)tnSelectedNode->Tag;
		int iMainIndex = pair[0];
		int iSubIndex = pair[1];

		string strFullName = DotNetStringToMultiByte( tbCastleFullName->Text );
		strcpy( vCastleInfoListData[iMainIndex][iSubIndex].szFullName, strFullName.c_str() );

		String^ strLine;
		if ( iSubIndex == 0 ) {
			strLine = String::Format( "{0:000} - {1}", iMainIndex, tbCastleFullName->Text);
		} else {
			strLine = String::Format( "{0}", tbCastleFullName->Text);
		}
		tnSelectedNode->Text = strLine;

		Castle_TextBoxWidthUpdate();
	}

	// eLXg{bNX́Auӂ肪ȁvύXꂽB
	void Castle_tbRubyYomi_TextChanged(Object^ sender, EventArgs^ e ) {
		// Im[hID
		TreeNode^ tnSelectedNode = tvCastleList->SelectedNode;
		List<int>^ pair = (List<int>^)tnSelectedNode->Tag;
		int iMainIndex = pair[0];
		int iSubIndex = pair[1];

		string strRubyYomi = DotNetStringToMultiByte( tbCastleRubyYomi->Text );
		strcpy( vCastleInfoListData[iMainIndex][iSubIndex].szRubyYomi, strRubyYomi.c_str() );
		Castle_TextBoxWidthUpdate();
	}


	// eLXg{bNX́Au`vύXꂽB
	void Castle_tbRetsuden_TextChanged(Object^ sender, EventArgs^ e ) {
		// Im[hID
		TreeNode^ tnSelectedNode = tvCastleList->SelectedNode;
		List<int>^ pair = (List<int>^)tnSelectedNode->Tag;
		int iMainIndex = pair[0];
		int iSubIndex = pair[1];

		string strRetsuden = DotNetStringToMultiByte( tbCastleRetsuden->Text );
		strcpy( vCastleRetsudenInfoListData[iMainIndex][iSubIndex].szRetsuden, strRetsuden.c_str() );
		Castle_TextBoxWidthUpdate();
	}

};

